#include<stdio.h>
#include<string.h>

#define SIZE 20

int main (int argc, char *argv[]) {
	char format[20];
	char message1[SIZE], message2[SIZE];
	int length, comparison_result;

	sprintf(format, "%%%ds", SIZE-1);
	printf("Enter first message: ");
	scanf(format, message1);  // scanf("%19s", message);
	printf("Enter second message: ");
	scanf(format, message2);

	printf("========\nTEST strlen:\n");
	length = strlen(message1);
	printf("The first message has length %d\n", length);
	printf("The character at position length is '%c'\n", message1[length]);  // it is '\0' which is not printable

	printf("========\nTEST strcmp:\n");
	printf("message1 is : %s\n", message1);
	printf("message2 is : %s\n", message2);
	comparison_result = strcmp(message1, message2);
	printf("The result of strcmp(\"%s\", \"%s\") is %d\n", 
		message1, message2, comparison_result);
	if (comparison_result > 0) {
		printf("\"%s\" is lexicographically larger that \"%s\"\n", message1, message2);
	}
	else if (comparison_result < 0) {
		printf("\"%s\" is lexicographically smaller that \"%s\"\n", message1, message2);
	}
	else {
		printf("\"%s\" is lexicographically equal to \"%s\"\n", message1, message2);
	}

	printf("========\nTEST strcat:\n");
	printf("message1 is : %s\n", message1);
	printf("message2 is : %s\n", message2);

	/* Before using strcat, make sure the destination string can fit everything.
	strcat will NOT check that there is enough space */
	if (strlen(message1)+strlen(message2)+1 < SIZE) {    // +1 for '\0'
		strcat(message1, message2);
		printf("message1 is now: %s\n", message1);
		printf("message2 is still: %s\n", message2);
	}
	else {
		printf("strcat canceled - not enough space in destination.\n");
	}

	printf("========\nTEST strcpy:\n");
	printf("message1 is : %s\n", message1);
	printf("message2 is : %s\n", message2);

	/* Before using strcpy, make sure the destination string can fit the source.
	strcpy will NOT check that there is enough space */
	if (strlen(message2)+1 < SIZE) {
		strcpy(message1, message2);
		printf("message1 is now: %s\n", message1);
		printf("message2 is still: %s\n", message2);
	}
	else {
		printf("strcpy canceled - not enough space in destination.\n");
	}
		
	return 0;
}
